   -- , 뢠騩 ࠪ ⨯  (), -
   -- 騩 ᫮  ॢ ᪠  砬, ।-
   -- ⠢ ᫥騬 :
   --
   --   data KBTree = Nil | Node (Int,String) (KBTree) (KBTree)
   --
   -- : ..楢 (28.02.2012)
   -- **********************************
   module TreeK
      (KBTree (Nil,Node),
      --------------------------------------------------------
      --  ।⠢ "饣"  室 㤠
      -- 祭 ஢  (Nil,Node)
      -----------------------------------------------------
       nil, list, node,                     -- 
       root, left, right,                   -- 
       isEmpty, isNode,                     -- ।
       -------------------------------------------------
       addTree, 
       consTree, consTree', consTree'',
       delete, ud, delete', ud',
       klpObh, lpkObh, lkpObh, klkpObh,
       drawTree, outTree, outTreeD, outTree')
   where
   --  ⨯
   --     |    
   --     |      |     |
   --     |      |     |
   data KBTree = Nil | Node (Int,String) (KBTree) (KBTree)
      deriving (Eq)
   -- *******************************
   --   ⨯ KBTree
   -- *******************************************
   --  ⮣ ୮ ॢ ᪠
   ----------------------------------------------
   nil:: KBTree
   nil = Nil
   --------------------------------------------
   --   ୮ ॢ ᪠
   --------------------------------------------
   list:: (Int,String) -> KBTree
   list x = Node x Nil Nil
   -----------------------------------------------
   --  設 ୮ ॢ ᪠,
   --  饩 ⮬
   -------------------------------------------------
   node:: (Int,String) -> KBTree -> KBTree -> KBTree
   node x l r = Node x l r
   -- ****************************
   --   ⨯ KBTree
   -- **********************************************************
   -- 㭪-ᥫ,  ७ ॢ ᪠ KBTree
   -------------------------------------------------------------
   root:: KBTree -> (Int,String)
   root Nil          = error "ॢ "
   root (Node a l r) = a
   --------------------------------------------------------
   -- 㭪-ᥫ,   ॢ ॢ
   -- ᪠ KBTree
   -----------------------
   left:: KBTree -> KBTree
   left Nil          = nil
   left (Node a l r) = l
   ---------------------------------------------------------
   -- 㭪-ᥫ,  ࠢ ॢ ॢ
   -- ᪠ KBTree
   ------------------------
   right:: KBTree -> KBTree
   right Nil          = nil
   right (Node a l r) = r
   -- ************************************************************
   -- ।  ᯮ ஢  ⨯ KBTree
   -- (⮢ ࠧ祭 ꥤ)
   -- *******************************************
   -- ।  ᯮ  Nil
   ----------------------------------------------
   isEmpty:: KBTree -> Bool 
   isEmpty Nil = True
   isEmpty _   = False
   -----------------------------------------------
   -- ।  ᯮ  Node
   -----------------------------------------------
   isNode:: KBTree -> Bool
   isNode = not.isEmpty
   -- *****************************************************
   -- 㭪,   x  ॢ ᪠ KBTree
   --------------------------------------------------------
   addTree:: (Int,String) -> KBTree -> KBTree
   addTree x tree | isEmpty tree = list x
                  | fst x==fst (root tree) 
                                 = tree
                  | fst x<fst (root tree)  
                                 = node (root tree)
                                        (addTree x (left tree))
                                        (right tree)
                  | True         = node (root tree) 
                                        (left tree)
                                        (addTree x (right tree))
   -----------------------------------------------------------
   -- 㭪-,  ୮ ॢ ᪠ 
   -- ஢ ᯨ᪠ lst,  ண "㯠"
   --  ॢ  浪  ᫥  ᯨ᪥
   --------------------------------------------
   consTree:: [(Int,String)] -> KBTree
   consTree lst | lst==[] = nil
                | True    = addTree (last lst) 
                                    (consTree (init lst))
   -----------------------------------------------------------
   -- 㭪-,  ୮ ॢ ᪠ 
   -- ஢ ᯨ᪠ lst,  ண "㯠"
   --  ॢ  浪  ᫥  ᯨ᪥
   -- (筠 )
   -------------------------------------
   consTree'':: [(Int,String)] -> KBTree
   consTree'' = (.) (foldr addTree nil) reverse
   -----------------------------------------------------------
   -- 㭪-,  ୮ ॢ ᪠ 
   -- ஢  ᯨ᪠,   ண "㯠" 
   -- ॢ  浪, ⭮  ᫥  ᯨ᪥
   ----------------------------------------------------
   consTree':: [(Int,String)] -> KBTree
   consTree' = foldr addTree nil
   -------------------------------------------------------------
   -- 㭪, 㤠 㧥 x  ୮ ॢ ᪠ tree.
   -- 㭪樨 delete()  ud() "᫮"   ᮮ⢥-
   -- 騥 ४ᨢ 楤 . [1985] ( Pascal)
   -- ( ᯮᮡ)
   -----------------------------------------
   delete:: (Int,String) -> KBTree -> KBTree
   delete x tree | isEmpty tree = nil
                 | fst x<fst (root tree)  
                                = node (root tree) 
                                       (delete x (left tree))
                                       (right tree)
                 | fst x>fst (root tree)  = node (root tree) 
                                       (left tree)
                                       (delete x (right tree))
                 | isEmpty (right tree)
                                = left tree
                 | isEmpty (left tree)
                                = right tree
                 | True         = node (ud (left tree))
                                       (delete (ud (left tree))
                                               (left tree))
                                       (right tree)
   -------------------------------------------------------
   -- 㭪,  ᠬ ࠢ  ୮
   -- ॢ ᪠ tree
   ---------------------------
   ud:: KBTree -> (Int,String)
   ud tree | isEmpty (right tree) = root tree
           | True                 = ud (right tree)
   --------------------------------------------------------
   -- 㭪, 㤠 㧥 x  ୮ ॢ ᪠.
   -- 㭪樨 delete'()    ud'()  ᮮ⢥騥
   -- ४ᨢ 楤 . [1985] ( Pascal)
   -- (ன ᯮᮡ)
   ------------------------------------------
   delete':: (Int,String) -> KBTree -> KBTree
   delete' x tree 
              | isEmpty tree = nil
              | fst x<fst (root tree)  
                             = node (root tree) 
                                    (delete' x (left tree))
                                    (right tree)
              | fst x>fst (root tree)  
                             = node (root tree) 
                                    (left tree)
                                    (delete' x (right tree))
              | isEmpty (right tree)
                             = left tree
              | isEmpty (left tree)
                             = right tree
              | True         = node (ud' (right tree))
                                    (left tree)
                                    (delete' (ud' (right tree))
                                             (right tree))
   -------------------------------------------------------
   -- 㭪,  ᠬ  
   -- ୮ ॢ ᪠ tree
   -------------------------------
   ud':: KBTree -> (Int,String)
   ud' tree | isEmpty (left tree) = root tree
            | True                = ud' (left tree)
   -----------------------------------------------------
   -- 㭪, ⢫ ஭ (室騩)
   -- 室 ୮ ॢ ᪠ tree
   -------------------------------------
   klpObh:: KBTree -> [(Int,String)]
   klpObh tree | isEmpty tree = []
               | True         =   [root tree]
                               ++ klpObh (left tree)
                               ++ klpObh (right tree)
   ------------------------------------------------------
   -- 㭪, ⢫ 楢 (室騩) 室
   -- ୮ ॢ ᪠ tree
   ---------------------------------
   lpkObh:: KBTree -> [(Int,String)]
   lpkObh tree | isEmpty tree = []
               | True         =   lpkObh (left tree)
                               ++ lpkObh (right tree)
                               ++ [root tree]
   -----------------------------------------------------
   -- 㭪, ⢫  (ᬥ蠭) 室
   -- ୮ ॢ ᪠ tree
   ---------------------------------
   lkpObh:: KBTree -> [(Int,String)]
   lkpObh tree | isEmpty tree = []
               | True         =   lkpObh (left tree)
                               ++ [root tree]
                               ++ lkpObh (right tree)
   --------------------------------------------------
   -- 㭪, ⢫ ⢥ 室
   -- ୮ ॢ ᪠ tree
   ----------------------------------
   klkpObh:: KBTree -> [(Int,String)]
   klkpObh tree | isEmpty tree = []
                | True         =    [root tree]
                                ++ klkpObh (left tree)
                                ++ [root tree]
                                ++ klkpObh (right tree)
   -- *************************************************
   -- 㠫 ୮ ॢ ᪠
   -- ******************************************************
   -- 㭪, ࠦ ॢ ᪠ tree   ப
   -- ᨬ; l - 騩 ࠬ, 祭 -
   --   ࢮ 맮 㭪樨 ࠢ 0
   -- ( ᯮ짮 ࠭)
   ----------------------------------
   drawTree:: KBTree -> Int -> String
   drawTree tree l | isEmpty tree = ""
                   | True         = drawTree (right tree) (l+1) ++
                                    "\n" ++ 
                                    replicate (l*3) ' ' ++
                                    show (root tree) ++
                                    drawTree (left tree) (l+1)
   -----------------------------------------------------------
   -- 㭪, ࠦ ॢ ᪠ tree    
   -- ப ᨬ; l - 騩 ࠬ, 祭 
   -- ண  ࢮ 맮 㭪樨 ࠢ 0
   -- ( ᯮ짮 ࠭)
   -----------------------------------
   drawTreeD:: KBTree -> Int -> String
   drawTreeD tree l | isEmpty tree = ""
                    | True         = drawTreeD (right tree) (l+1) ++
                                     "\n" ++ 
                                     replicate (l*3) ' ' ++
                                     show (snd (root tree)) ++
                                     drawTreeD (left tree) (l+1)
   -------------------------------------------------------------
   -- 㭪, ࠦ ॢ ᪠ tree   ப
   -- ᨬ; l - 騩 ࠬ, 祭 -
   --   ࢮ 맮 㭪樨 ࠢ 0
   -- ( ᯮ짮 ᮯ⠢  ࠧ殬)
   ----------------------------------------------
   drawTree':: KBTree -> Int -> String
   drawTree' Nil k          = ""
   drawTree' (Node x l r) k = drawTree' r (k+1)
                              ++ "\n" ++ replicate (k*3) ' '
                              ++ show x
                              ++ drawTree' l (k+1)
   ----------------------------------------------------
   -- 㭪, ࠦ ୮ ॢ ᪠ tree
   --  ࠭ ᯫ
   ------------------------
   outTree:: KBTree -> IO()
   outTree tree = putStr (drawTree tree 0 ++ "\n")
   ----------------------------------------------------
   -- 㭪, ࠦ ୮ ॢ ᪠ tree
   --  ࠭ ᯫ
   -------------------------
   outTreeD:: KBTree -> IO()
   outTreeD tree = putStr (drawTreeD tree 0 ++ "\n")
   ------------------------------------------------------
   -- 㭪, ।⠢ ୮ ॢ ᪠ tree
   --   "筮" ᯨ᪠, ..  㪠  -
   --  Node
   -------------------------
   outTree':: KBTree -> IO()
   outTree' tree = putStr (show tree)
   --------------------------------------------------------
   -- ।⠢ ⨯ BTree  ⢥  
   -- Show  ।  ⮤, ।⠢饣 ୮
   -- ॢ ᪠  㪠   Node
   -----------------------------------------------------
   instance Show KBTree
     where show tree | isEmpty tree = "Nil"
                     | list (root tree)==tree 
                                    = "(" ++ show (root tree) ++
                                      " Nil" ++ " Nil" ++ ")"
                     | True         = "(" ++ show (root tree) ++
                                      " " ++ show (left tree) ++
                                      " " ++ show (right tree) ++ ")"
